package net.sf.sido.factory.json;

import java.io.IOException;

import net.sf.sido.DataFactory;
import net.sf.sido.DataType;

import org.codehaus.jackson.JsonNode;

import com.google.common.base.Predicate;

public abstract class AbstractPropertyAssembler implements PropertyAssembler {

	protected final String name;

	public AbstractPropertyAssembler(String name) {
		this.name = name;
	}

	protected DataType getDOType(JSONReaderContext context, JSONDataFactory factory, String type) throws IOException {
		return factory.getDOType(context, type);
	}

	protected boolean isNullable(JsonNode jProperty) {
		return JSONUtils.getBoolean(jProperty, "nullable", false, false);
	}

	protected <T> Predicate<T> readConstraint(DataFactory factory, JsonNode j, String name) {
		JsonNode jConstraint = j.get(name);
		if (jConstraint == null || jConstraint.isNull()) {
			return null;
		} else {
			// Makes the constraint using the factory
			Predicate<T> constraint = factory.getConstraintFactory().createConstraint(
					new JSONConstraintDefinitions(jConstraint));
			// Sets the constraint
			return constraint;
		}
	}

}
