package net.sf.sido.factory.json;

import java.io.IOException;

import net.sf.sido.DataObject;

import org.codehaus.jackson.JsonNode;

import com.google.common.base.Predicate;

public class AnonymousPropertyAssembler extends AbstractPropertyAssembler {

	public AnonymousPropertyAssembler(String name) {
		super(name);
	}

	@Override
	public <T> void addProperty(JSONReaderContext context, JSONDataFactory factory, JSONTypeDefinition definition,
			JsonNode jProperty) throws IOException {
		// Property information
		boolean nullable = isNullable(jProperty);
		boolean reverse = JSONUtils.getBoolean(jProperty, "reverse", false, true);
		// Constraint
		Predicate<DataObject> constraint = readConstraint(context.getFactory(), jProperty, "constraint");
		// Adds the property
		definition.getBuilder().addAnonymousProperty(name, reverse, nullable, constraint);
	}

}
