package net.sf.sido.factory.json;

import java.io.IOException;

import net.sf.sido.DataObject;
import net.sf.sido.DataType;

import org.codehaus.jackson.JsonNode;

import com.google.common.base.Predicate;

public class DOPropertyAssembler extends AbstractPropertyAssembler {

	private final String type;

	public DOPropertyAssembler(String name, String type) {
		super(name);
		this.type = type;
	}

	@Override
	public <T> void addProperty(JSONReaderContext context, JSONDataFactory factory, JSONTypeDefinition definition,
			JsonNode jProperty) throws IOException {
		DataType tType = getDOType(context, factory, type);
		// Property information
		boolean nullable = isNullable(jProperty);
		boolean reverse = JSONUtils.getBoolean(jProperty, "reverse", false, true);
		// Constraint
		Predicate<DataObject> constraint = readConstraint(context.getFactory(), jProperty, "constraint");
		// Adds the property
		definition.getBuilder().addDOProperty(name, tType, reverse, nullable, constraint);
	}

}
