package net.sf.sido.factory.json;

import java.util.ArrayList;
import java.util.List;

import net.sf.sido.constraint.ConstraintDefinition;
import net.sf.sido.constraint.ConstraintDefinitions;

import org.codehaus.jackson.JsonNode;

public class JSONConstraintDefinitions implements ConstraintDefinitions {

	private final JsonNode jConstraint;

	public JSONConstraintDefinitions(JsonNode jConstraint) {
		this.jConstraint = jConstraint;
	}

	@Override
	public List<ConstraintDefinition> getConstraintDefinitions() {
		List<ConstraintDefinition> list = new ArrayList<ConstraintDefinition>();
		if (jConstraint.isArray()) {
			for(JsonNode jNode : jConstraint) {
				list.add(new JSONConstraintDefinition(jNode));
			}
		} else {
			list.add(new JSONConstraintDefinition(jConstraint));
		}
		return list;
	}

}
