package net.sf.sido.support;

import net.sf.jstring.JStrings;
import net.sf.sido.DOException;
import net.sf.sido.ValidationError;

import java.util.Locale;

public class DefaultValidationError implements ValidationError {

	private final String name;

	private final DOException error;

	public DefaultValidationError(String name, DOException error) {
		this.name = name;
		this.error = error;
	}

	@Override
	public DOException getError() {
		return this.error;
	}

	@Override
	public String getName() {
		return this.name;
	}

    @Override
    public String getMessage() {
        return getMessage(Locale.getDefault());
    }

    @Override
    public String getMessage(Locale locale) {
        // Error message
        String errorMessage = error.getLocalizedMessage(locale);
        // Format the error message together with the name
        return JStrings.get(locale, "sido.ValidationError", name, errorMessage);
    }
}
